︠9da6f1e3-141b-48aa-bc0c-fc62bd6f7f1f︠
# Algorithm to plot Thue equation, solutions and roots given a thue equation
def thue_graph_finder(thue_input, c):
    R.<x,y> = QQbar[]
    ts = []
    thue_eq = thue_input(y=1)
    thue_eq2 = thue_eq.univariate_polynomial()
    print thue_eq2
    thue_eq_roots = thue_eq2.roots()
    eq_roots = []
    for p in thue_eq_roots:
        eq_roots.append(CC(p[0]))
    th_init = gp.thueinit(thue_eq2,1)
    sols = gp.thue(th_init,c)

    for p in sols:
        print p
        if p[1] != 0 and p[2] != 0:
            t = p[1] / p[2]
            ts.append(CC(t))

    approx_plot = plot([0,0], xmin = -100, ymin = -100, xmax = 100, ymax = 100)
    if len(ts) > 0:
        approx_plot = point(ts, pointsize=100, color = "red")
    root_plot = point(eq_roots, pointsize=100)
    show(root_plot + approx_plot)

from sage.misc.html import HtmlFragment
R.<x,y> = QQbar[]
F.<x> = ZZ[]
p = F.random_element(3).homogenize(y)
@interact
def _(thue_input = input_box(p, label = '$f$'), c = input_box(ZZ.random_element(1, 50))):
    print(thue_graph_finder(thue_input, c))
︡701c3dc2-86b4-47e4-a9a3-eea55b0ae856︡{"interact":{"controls":[{"control_type":"input-box","default":"2*x^3 + 4*x*y^2 - 2*y^3","label":"$f$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"thue_input","width":null},{"control_type":"input-box","default":25,"label":"c","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"c","width":null}],"flicker":false,"id":"1c58f68d-692d-43de-9282-b49ac5dca618","layout":[[["thue_input",12,null]],[["c",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠7b96cf97-582e-4397-9601-e091044c1ebc︠


def plane_curve_finder(thue_input,c):
    ts = []
    thue_eq = thue_input(y=1)
    thue_eq2 = thue_eq.univariate_polynomial()
    th_init = gp.thueinit(thue_eq2,1)
    # what gp returns is "gp integers", which are not sage integers.
    # This line will convert "gp integers" to the usual sage ZZ elements.
    sols = [map(ZZ,a) for a in gp.thue(th_init,c)]
    for p in sols:
            ts.append(p)

    approx_plot = point([0,0], color = "white")
    if len(ts) > 0:
        approx_plot += point(ts, pointsize=100, color = "red")
    curve_plot = implicit_plot(thue_input - c, (x,-10,10), (y,-10,10))
    show(curve_plot + approx_plot)


from sage.misc.html import HtmlFragment
R.<x,y> = QQbar[]
F.<x,y> = ZZ[]
p = F.random_element(3)

@interact
def _(thue_input = input_box(p, label = '$f$'), c = input_box(17)):
    print(plane_curve_finder(thue_input, c))
︡99410e42-ee23-4b37-bfd7-d15b03367728︡{"interact":{"controls":[{"control_type":"input-box","default":"3*x^3 - 6*x*y^2 + y^3 - y^2 + 4*y","label":"$f$","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"thue_input","width":null},{"control_type":"input-box","default":17,"label":"c","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"c","width":null}],"flicker":false,"id":"457d84b8-477f-4de1-952c-59484662f7f7","layout":[[["thue_input",12,null]],[["c",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡









